using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_EntityFramework;
using Exferia_Formularios;
using Exferia_General._0_Modelos;
using Exferia_General._3_Vistas.Controladoras;
using Exferia_General._3_Vistas.ListadosSeleccion;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_General._3_Vistas
{
    public partial class P_Moneda : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables General
        private P_Moneda_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        private Timer g_timer_Filtrar_Agrupaciones = new Timer();

        //Variables paginador......................................................................................
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private Timer g_timer_Paginar = new Timer();

        private INTERNO_ConfiguracionPantalla_Modelo g_mdl_INTERNO_ConfiguracionPantalla_Modelo = null;
        #endregion

        #region Objetos en Pantalla
        // Exferia_Label
        internal Exferia_Label Exferia_Label_Moneda { get { return ex_lbl_P_Moneda_Moneda; } }
        internal Exferia_Label Exferia_Label_Descripcion { get { return ex_lbl_P_Moneda_Descripcion; } }
        internal Exferia_Label Exferia_Label_Identificador { get { return ex_lbl_P_Moneda_Identificador; } }
        internal Exferia_Label Exferia_Label_RedondeoPrecio { get { return ex_lbl_P_Moneda_RedondePrecio; } }
        internal Exferia_Label Exferia_Label_RedondeoImporte { get { return ex_lbl_P_Moneda_RedondeoImporte; } }

        // Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_Moneda { get { return ex_txt_P_Moneda_Moneda; } }
        internal Exferia_TextBox Exferia_TextBox_Descripcion { get { return ex_txt_P_Moneda_Descripcion; } }
        internal Exferia_TextBox Exferia_TextBox_Identificador { get { return ex_txt_P_Moneda_Identificador; } }
        internal Exferia_TextBox Exferia_TextBox_RedondeoPrecio { get { return ex_txt_P_Moneda_RedondeoPrecio; } }
        internal Exferia_TextBox Exferia_TextBox_RedondeoImporte { get { return ex_txt_P_Moneda_RedondeoImporte; } }
        internal Exferia_TextBox Exferia_TextBox_NumeroInternacional { get { return ex_txt_P_Moneda_NumeroInternacional; } }

        // Exferia_Button
        internal Exferia_Button Exferia_Button_Borrar { get { return ex_btn_P_Moneda_Borrar; } }

        // Exferia_DataGridView
        internal Exferia_DataGridView Exferia_DataGridView_Listado { get { return ex_dgv_P_MonedaHistorico_Listado; } }

        // Exferia_BarraProgreso
        internal Exferia_BarraProgreso Exferia_BarraProgreso_MonedaHistorico { get { return ex_pgb_P_MonedaHistorico_BarraProgreso; } }

        // Exferia_Paginador
        internal Exferia_Paginador Exferia_Paginador_Monedas { get { return ex_Paginador; } }

        #endregion

        #region Constructor
        public P_Moneda(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo, DateTime _dtt_FechaTrabajo, PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle)
        {
            InitializeComponent();

            try
            {
                Repintar.Empezar(this);

                CheckForIllegalCrossThreadCalls = false;

                //Empresa seleccionada y fecha de trabajo ....................................................
                P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
                P_Base_FechaTrabajo = _dtt_FechaTrabajo;

                //Instanciar Controladora
                g_obj_Controladora = new P_Moneda_Controladora(this);

                //Datos de Opciones detalle
                g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

                //Buscar los Permisos
                g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);

                //Poner los Botones que no se Spueden poner bloqueados o de solo lectura
                ex_btn_P_Moneda_Borrar.Exferia_Button_Bloqueable = false;
                ex_btn_P_Moneda_Grabar.Exferia_Button_Bloqueable = false;

                //Mirar si hay que bloquear los controles, si solo puede ver los datos
                if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
                {
                    //Bloqueo los Controles
                    SoloLectura.Empezar(this, true);
                }

                //Titulo de la Pantalla .............................................................................
                P_Base_TituloPantalla = _mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

                if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
                {
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos.NOMBRELISTADO_ALMACENARCONFIGURACION()))
                    {
                        g_mdl_INTERNO_ConfiguracionPantalla_Modelo = Variables.G_DCT_CONFIGURACIONPANTALLA[g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos.NOMBRELISTADO_ALMACENARCONFIGURACION()];
                    }
                }

                //Tipo de campo Codigo, poner como numérico o texto ...............................
                if (Variables.G_LST_GEN_CONFIGURACION_CAMPOCODIGO != null)
                {
                    //Si no existe es Text
                    if (Variables.G_LST_GEN_CONFIGURACION_CAMPOCODIGO.Where(m => m.nombreCampoCodigo.Equals(nameof(GEN_Monedas.moneda)) && m.opcion.Equals(g_mdl_PRV_OpcionesDetalle.opcion)).FirstOrDefault() != null)
                    {
                        ex_txt_P_Moneda_Moneda.Exferia_TextBox_Tipos = G_ENUM_TEXTBOX_TIPODATO.Digitos;
                        ex_txt_P_Moneda_Moneda.Exferia_TextBox_Tipo_Decimal_Enteros = ex_txt_P_Moneda_Moneda.Exferia_TextBox_MaxLength;

                        g_obj_Controladora.g_bol_CampoCodigo_Numerico = true;
                    }
                }
                //................................................................................

                // Label con Empresa Seleccionada 
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Moneda) + "/" + nameof(P_Moneda));
                    }
                }
                //....................................................................................................

                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = false;
                //.............................................................

                g_obj_Funciones_Paginador = new Funciones_Paginador();

            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Moneda) + "/" + nameof(P_Moneda));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = true;
                //.............................................................
            }
        }
        #endregion

        #region Inicio de pantalla
        private void P_Moneda_Load(object sender, EventArgs e)
        {
            try
            {
               
                //Crear Columnas Listado
                CrearColumnas();

                //Poner el tipo de orden si lo hubiera por defecto ######################################
                if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_ORDEN_DIRECCION_PORDEFECTO != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_ORDEN_DIRECCION_PORDEFECTO.Trim().Length > 0)
                {
                    //Descendente
                    if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_ORDEN_DIRECCION_PORDEFECTO.Equals("1"))
                    {
                        Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_P_MonedaHistorico_OrdenListado);
                        ex_btn_P_MonedaHistorico_OrdenListado.Tag = "1";

                    }
                    //Ascendente
                    else
                    {
                        Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_P_MonedaHistorico_OrdenListado);
                        ex_btn_P_MonedaHistorico_OrdenListado.Tag = "0";
                    }
                }
                else
                {
                    if (g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos.ORDENACION_TIPO_PORDEFECTO().Trim().Length > 0)
                    {
                        //Descendente
                        if (g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos.ORDENACION_TIPO_PORDEFECTO().Equals("1"))
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_P_MonedaHistorico_OrdenListado);
                            ex_btn_P_MonedaHistorico_OrdenListado.Tag = "1";
                        }
                        //Ascendente
                        else
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_P_MonedaHistorico_OrdenListado);
                            ex_btn_P_MonedaHistorico_OrdenListado.Tag = "0";

                        }
                    }
                }

                //Seleccionar Orden por Defecto en Combo #################################################
                if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_ORDEN_COLUMNA_PORDEFECTO != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_ORDEN_COLUMNA_PORDEFECTO.Trim().Length > 0)
                {
                    ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem = ex_cbo_P_MonedaHistorico_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().Where(m => m.Descripcion.Equals(g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_ORDEN_COLUMNA_PORDEFECTO)).FirstOrDefault();
                }
                else
                {
                    if (g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos.ORDENACION_NOMBRECOLUMNA_PORDEFECTO().Trim().Length > 0)
                    {
                        ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem = ex_cbo_P_MonedaHistorico_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().Where(m => m.Identificador.Equals(g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos.ORDENACION_NOMBRECOLUMNA_PORDEFECTO())).FirstOrDefault();
                    }
                    else
                    {
                        ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem = ex_cbo_P_MonedaHistorico_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().FirstOrDefault();
                    }
                }

                //Configurar el Timer para Paginacion ###############################################################
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }

                };
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Moneda) + "/" + nameof(P_Moneda_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }

        private void P_Moneda_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                   
                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (this.P_Base_TipoAperturaPantalla == 0)
                    {
                        P_Base_TituloPantalla = P_Base_TituloPantalla + " - Añadir";

                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;
                        //Poner Texto predeterminado y foco
                        if ((P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0) ||
                            (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0))
                        {
                            if (P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0)
                            {
                                ex_txt_P_Moneda_Moneda.Text = P_Base_Campo_1;
                                ex_txt_P_Moneda_Descripcion.Exferia_TextBox_Foco();
                            }
                            if (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0)
                            {
                                ex_txt_P_Moneda_Descripcion.Text = P_Base_Campo_2;
                                ex_txt_P_Moneda_Moneda.Exferia_TextBox_Foco();
                            }
                        }
                        else
                        {
                            ex_txt_P_Moneda_Moneda.Exferia_TextBox_Foco();
                        }
                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = false;

                        ActivarBotones(false);
                    }
                    // Modificar
                    else
                    {
                        ActivarBotones(true);

                        //Paginacion
                        if (P_Base_PantallaOrigen != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                        {
                            g_obj_Funciones_Paginador.Listado_ARecorrer(P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.ToList(), 1);

                            // Asignando las paginas totales
                            Exferia_Paginador_Monedas.PaginasTotales = g_obj_Funciones_Paginador.Numero_Paginas_Totales;
                        }
                        else
                        {
                            Exferia_Paginador_Monedas.Visible = false;
                        }

                        g_obj_Controladora.RecargarDatos();
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Moneda) + "/" + nameof(P_Moneda_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }
        public void ActivarBotones(bool _bol_Activar)
        {
            if (Exferia_Paginador_Monedas.Visible)
            {
                Exferia_Paginador_Monedas.Visible = _bol_Activar;
            }

            if (ex_btn_P_Moneda_Borrar.Enabled)
            {
                ex_btn_P_Moneda_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        #region Botones Grabar,Borrar,BuscarCodigoSiguiente
        private void ex_btn_P_Moneda_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if ( //Añadir
                (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                //Modificar
                (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
            {
                g_obj_Controladora.GrabarDatos();
            }
        }

        private void ex_btn_P_Moneda_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                g_obj_Controladora.BorrarDatos(true);
            }
        }

        private void ex_btn_P_Moneda_BuscarCodigoSiguiente_Click(object sender, EventArgs e)
        {
            BuscarCodigoSiguiente();
        }
        private void BuscarCodigoSiguiente()
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = g_obj_Controladora.Buscar_CodigoSiguiente();
            if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto == false && mdl_INTERNO_ValorDevuelto_Modelo.Mensaje.Trim().Length > 0)
            {
                Mensajes.MostrarMensaje(mdl_INTERNO_ValorDevuelto_Modelo.Mensaje);
            }
            else
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }
        #endregion

        #region MonedasHistorico
        private void CrearColumnas()
        {
            ex_dgv_P_MonedaHistorico_Listado.AutoGenerateColumns = false;

            g_obj_Controladora.g_lst_INTERNO_ABS_Listado_ColumnasDatos_Modelo_Columnas = g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos.LISTADO_COLUMNAS().Values.ToList();

            foreach (INTERNO_ABS_Listado_ColumnasDatos_Modelo mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo in g_obj_Controladora.g_lst_INTERNO_ABS_Listado_ColumnasDatos_Modelo_Columnas)
            {
                dynamic dgv_Columna;

                //Si fuera de tipo Seleccionar se pone la celda con un check
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.SELECCIONAR))
                {
                    dgv_Columna = new DataGridViewCheckBoxColumn();
                    dgv_Columna.ReadOnly = false;
                }
                else
                {
                    dgv_Columna = new DataGridViewTextBoxColumn();
                    dgv_Columna.ReadOnly = true;
                }

                dgv_Columna.DataPropertyName = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna;
                dgv_Columna.Name = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna;
                dgv_Columna.HeaderText = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_AMostrar;

                //Poner visible o no .........................................................................
                bool bol_Visible = true;
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Oculto)
                {
                    bol_Visible = false;
                }
                else if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo != null &&
                         g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNASAMOSTRAR != null &&
                         g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNASAMOSTRAR.Count > 0)
                {
                    if (!g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNASAMOSTRAR.Contains(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna))
                    {
                        bol_Visible = false;
                    }
                }
                else if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Mostrado_PorDefecto == false)
                {
                    bol_Visible = false;
                }
                dgv_Columna.Visible = bol_Visible;


                if (bol_Visible)
                {
                    g_obj_Controladora.g_lst_ColumnasAMostrar.Add(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna);
                }
                //.....................................................................................................

                //Tipo de Formateo si fuera Fecha
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DATETIME))
                {
                    dgv_Columna.DefaultCellStyle.Format = "d";
                }


                //Poner Ancho Columna ................................................................................
                if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNAS_ANCHO != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNAS_ANCHO.Count > 0 &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNAS_ANCHO.ContainsKey(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna))
                {
                    dgv_Columna.Width = g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNAS_ANCHO[mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna];
                }
                else
                {
                    if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Ancho > 0)
                    {
                        dgv_Columna.Width = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Ancho;
                    }
                }
                //................................................................................................................



                //Poner alineado segun tipo de datos ......................................................................................
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DECIMAL) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG_TEXT) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.INT))
                {
                    dgv_Columna.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
                }
                else
                {
                    dgv_Columna.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft;
                }
                //..............................................................................................................................

                ex_dgv_P_MonedaHistorico_Listado.Columns.Add(dgv_Columna);

                //RELLENAR EL ORDEN EN COMBO
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Oculto == false)
                {
                    ex_cbo_P_MonedaHistorico_OrdenListado.Items.Add(new INTERNO_ComboBox_Modelo(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna, mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_AMostrar, null));
                }

            }

            //Cambiar el orden de las columnas ........
            if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo != null && g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNAS_ORDEN != null && g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNAS_ORDEN.Count > 0)
            {
                foreach (KeyValuePair<string, int> kvp_Valores in g_mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNAS_ORDEN)
                {
                    ex_dgv_P_MonedaHistorico_Listado.Columns[kvp_Valores.Key].DisplayIndex = kvp_Valores.Value;
                }
            }
            //.........................................
        }

        #region Ordenar
        private void ex_btn_P_MonedaHistorico_OrdenListado_Click(object sender, EventArgs e)
        {
            //Esta Descedente
            if (ex_btn_P_MonedaHistorico_OrdenListado.Tag.ToString().Equals("1"))
            {
                Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_P_MonedaHistorico_OrdenListado);
            }
            //Esta Ascendente
            else
            {
                Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_P_MonedaHistorico_OrdenListado);
            }

            Ordenar_DataGridView();
        }
        private void ex_dgv_P_MonedaHistorico_Listado_ColumnHeaderMouseClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            try
            {
                //Mostrar u Ocultar las columnas
                if (e.Button == MouseButtons.Left)
                {
                    string str_CambioOrdenAnterior = "";
                    if (ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem != null)
                    {
                        str_CambioOrdenAnterior = ((INTERNO_ComboBox_Modelo)ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem).Identificador;
                    }

                    //Seleccionar la columna en el Combo de orden
                    ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem = ex_cbo_P_MonedaHistorico_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().Where(m => m.Identificador.Equals(ex_dgv_P_MonedaHistorico_Listado.Columns[e.ColumnIndex].Name)).FirstOrDefault();

                    if (str_CambioOrdenAnterior.Equals(((INTERNO_ComboBox_Modelo)ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem).Identificador))
                    {
                        //Si estaba Ascendente lo pongo descendente
                        if (ex_dgv_P_MonedaHistorico_Listado.SortOrder == SortOrder.Ascending)
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_P_MonedaHistorico_OrdenListado);
                        }
                        //Si estaba descendente lo pongo Ascendente
                        else
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_P_MonedaHistorico_OrdenListado);
                        }
                    }

                    Ordenar_DataGridView();
                }
            }
            catch
            { }
        }
        private void ex_cbo_P_MonedaHistorico_OrdenListado_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Saber el Tipo de Ordenacion .................................
            ListSortDirection obj_ListSortDirection = ListSortDirection.Ascending;
            if (ex_btn_P_MonedaHistorico_OrdenListado.Tag.ToString().Equals("1"))
            {
                obj_ListSortDirection = ListSortDirection.Descending;
            }
            //..............................................................

            //Cambiar el tipo Orden en Listado
            ex_dgv_P_MonedaHistorico_Listado.Sort(ex_dgv_P_MonedaHistorico_Listado.Columns[((INTERNO_ComboBox_Modelo)ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem).Identificador], obj_ListSortDirection);

            Ordenar_DataGridView();
        }

        public void Ordenar_DataGridView()
        {
            try
            {
                if (ex_dgv_P_MonedaHistorico_Listado.Rows.Count > 0)
                {
                    //Saber el Tipo de Ordenacion .................................
                    ListSortDirection obj_ListSortDirection = ListSortDirection.Ascending;
                    if (ex_btn_P_MonedaHistorico_OrdenListado.Tag.ToString().Equals("1"))
                    {
                        obj_ListSortDirection = ListSortDirection.Descending;
                    }
                    //..............................................................

                    if (ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem != null && ((INTERNO_ComboBox_Modelo)ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem).Identificador.Trim().Length > 0)
                    {
                        ex_dgv_P_MonedaHistorico_Listado.Sort(ex_dgv_P_MonedaHistorico_Listado.Columns[((INTERNO_ComboBox_Modelo)ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem).Identificador], obj_ListSortDirection);
                    }
                    else
                    {
                        ex_dgv_P_MonedaHistorico_Listado.Sort(ex_dgv_P_MonedaHistorico_Listado.Columns[g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos.ORDENACION_NOMBRECOLUMNA_PORDEFECTO()], obj_ListSortDirection);
                    }
                }
            }
            catch (Exception)
            { }
        }
        #endregion

        #region Filtros
        private void ex_btn_P_MonedaHistorico_Filtros_Click(object sender, EventArgs e)
        {
            MostrarOcultar_Columnas_Y_Fitros(ex_btn_P_MonedaHistorico_Filtros.Location.X, 0);
        }
        private void MostrarOcultar_Columnas_Y_Fitros(int _int_PosicionX, int _int_PosicionY)
        {
            PE_Listados_Filtros frm_PE_Listados_Filtros = new PE_Listados_Filtros(g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos, ex_dgv_P_MonedaHistorico_Listado.Columns, g_obj_Controladora.g_dct_ListadoFiltros);

            frm_PE_Listados_Filtros.ShowDialog();

            if (frm_PE_Listados_Filtros.g_bol_BotonAceptar)
            {
                //Mostrar/Ocultar las Columnas que no esten en el Listado
                g_obj_Controladora.g_lst_ColumnasAMostrar = frm_PE_Listados_Filtros.g_lst_ColumnasAMostrar;

                foreach (DataGridViewColumn dgvc_ColumnasActuales in ex_dgv_P_MonedaHistorico_Listado.Columns)
                {
                    //Mostrar
                    if (g_obj_Controladora.g_lst_ColumnasAMostrar.Contains(dgvc_ColumnasActuales.Name))
                    {
                        dgvc_ColumnasActuales.Visible = true;
                    }
                    //Ocultar
                    else
                    {
                        dgvc_ColumnasActuales.Visible = false;
                    }
                }

                //Rellenar los nuevos filtros
                g_obj_Controladora.g_dct_ListadoFiltros = frm_PE_Listados_Filtros.g_dct_ListadoFiltros.ToDictionary(entry => entry.Key, entry => entry.Value);

                //Recargar el Listado
                g_obj_Controladora.Rellenar_DataGrid();
            }
        }
        #endregion

        #region Botones
        private void ex_btn_P_MonedaHistorico_Add_Click(object sender, EventArgs e)
        {
            Add_Linea();
        }
        private void Add_Linea()
        {
            if ((Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_GEN_MONEDAHISTORICO, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)))
            {
                //Por si se modifico algo en la cabecera que se grabe
                if (g_obj_Controladora.ComprobarCambios_SinPreguntar())
                {
                    INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_GEN_MONEDAHISTORICO);

                    //Poner el Listado para el paginado ....................................................
                    List<INTERNO_GEN_MonedasHistoricos_Listado_Modelo> lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo = g_obj_Controladora.Filtrar_Linea();
                    if (lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo != null && lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo.Count > 0)
                    {
                        string str_CampoOrdenar =g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos.ORDENACION_NOMBRECOLUMNA_PORDEFECTO();
                        if (ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem != null && ((INTERNO_ComboBox_Modelo)ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem).Identificador.Trim().Length > 0)
                        {
                            str_CampoOrdenar = ((INTERNO_ComboBox_Modelo)ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem).Identificador;
                        }

                        //Descendente
                        if (ex_btn_P_MonedaHistorico_OrdenListado.Tag.ToString().Equals("1"))
                        {
                            lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo = lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo.OrderByDescending(m => m.GetType().GetProperty(str_CampoOrdenar).GetValue(m, null)).ToList();
                        }
                        //Ascendente
                        else
                        {
                            lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo = lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo.OrderBy(m => m.GetType().GetProperty(str_CampoOrdenar).GetValue(m, null)).ToList();
                        }

                        P_Base_Objetos_Filtrados = lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo.Select(m => new INTERNO_Listado_CamposClave_Modelo { ID = m.id }).ToList();
                    }
                    else
                    {
                        P_Base_Objetos_Filtrados = null;
                    }
                    //......................................................................................

                    //Buscar Opciones Modelo
                    P_MonedaHistorico frm_P_MonedaHistorico = new P_MonedaHistorico(P_Base_ValoresGenerales,
                                                                                    P_Base_FechaTrabajo,
                                                                                    mdl_INTERNO_OpcionesDetalle_Modelo,
                                                                                    g_obj_Controladora.g_mdl_INTERNO_GEN_Monedas_Modelo);

                    //Se llamo desde una pantalla
                    frm_P_MonedaHistorico.P_Base_TipoAperturaPantalla = 0;
                    frm_P_MonedaHistorico.P_Base_PantallaPadre_IdentificadorTAG = this.Tag.ToString();
                    frm_P_MonedaHistorico.P_Base_PantallaOrigen = this;
                    frm_P_MonedaHistorico.P_Base_TituloPantalla_CaminoHormigas = mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento.ToUpper() + " -> Alta";

                    Funciones_PanelPrincipal.Cargar_PantallaEmpotrada(frm_P_MonedaHistorico,Variables.G_STR_OPCION_GEN_MONEDAHISTORICO);
                }
            }
        }

        private void ex_btn_P_MonedaHistorico_Ver_Click(object sender, EventArgs e)
        {
            Ver_Linea();
        }
        private void ex_dgv_P_MonedaHistorico_Listado_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            Ver_Linea();
        }
        private void Ver_Linea()
        {
            if ((Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_GEN_MONEDAHISTORICO, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Ver, true)))
            {
                //Ver si hay alguno seleccionado
                if (ex_dgv_P_MonedaHistorico_Listado.Rows.Count > 0 && ex_dgv_P_MonedaHistorico_Listado.SelectedRows.Count > 0)
                {
                    //Por si se modifico algo en la cabecera que se grabe
                    if (g_obj_Controladora.ComprobarCambios_SinPreguntar())
                    {
                        INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_GEN_MONEDAHISTORICO);

                        //Poner el Listado para el paginado ....................................................
                        List<INTERNO_GEN_MonedasHistoricos_Listado_Modelo> lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo = g_obj_Controladora.Filtrar_Linea();
                        if (lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo != null && lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo.Count > 0)
                        {
                            string str_CampoOrdenar =g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos.ORDENACION_NOMBRECOLUMNA_PORDEFECTO();
                            if (ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem != null && ((INTERNO_ComboBox_Modelo)ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem).Identificador.Trim().Length > 0)
                            {
                                str_CampoOrdenar = ((INTERNO_ComboBox_Modelo)ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem).Identificador;
                            }

                            //Descendente
                            if (ex_btn_P_MonedaHistorico_OrdenListado.Tag.ToString().Equals("1"))
                            {
                                lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo = lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo.OrderByDescending(m => m.GetType().GetProperty(str_CampoOrdenar).GetValue(m, null)).ToList();
                            }
                            //Ascendente
                            else
                            {
                                lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo = lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo.OrderBy(m => m.GetType().GetProperty(str_CampoOrdenar).GetValue(m, null)).ToList();
                            }

                            P_Base_Objetos_Filtrados = lst_INTERNO_GEN_MonedasHistoricos_Listado_Modelo.Select(m => new INTERNO_Listado_CamposClave_Modelo { ID = m.id }).ToList();
                        }
                        else
                        {
                            P_Base_Objetos_Filtrados = null;
                        }
                        //......................................................................................

                        //Buscar Opciones Modelo
                        P_MonedaHistorico frm_P_MonedaHistorico = new P_MonedaHistorico(P_Base_ValoresGenerales,
                                                                                        P_Base_FechaTrabajo,
                                                                                        mdl_INTERNO_OpcionesDetalle_Modelo,
                                                                                        g_obj_Controladora.g_mdl_INTERNO_GEN_Monedas_Modelo);

                        frm_P_MonedaHistorico.P_Base_TipoAperturaPantalla = 1;
                        frm_P_MonedaHistorico.P_Base_PantallaPadre_IdentificadorTAG = this.Tag.ToString();
                        frm_P_MonedaHistorico.P_Base_PantallaOrigen = this;
                        frm_P_MonedaHistorico.P_Base_id = long.Parse(ex_dgv_P_MonedaHistorico_Listado.SelectedRows[0].Cells[nameof(INTERNO_GEN_MonedasHistoricos_Listado_Modelo.id)].Value.ToString());
                        frm_P_MonedaHistorico.P_Base_TituloPantalla_CaminoHormigas = mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento.ToUpper() + " -> Alta";

                        Funciones_PanelPrincipal.Cargar_PantallaEmpotrada(frm_P_MonedaHistorico,Variables.G_STR_OPCION_GEN_MONEDAHISTORICO);
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_NOHAYREGISTROSSELECCIONADOS());
                }
            }
        }

        private void ex_btn_P_MonedaHistorico_Borrar_Click(object sender, EventArgs e)
        {
            Borrar_Linea();
        }
        private void Borrar_Linea()
        {
            if (Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_GEN_MONEDAHISTORICO, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                //Ver si hay alguno seleccionado
                if (ex_dgv_P_MonedaHistorico_Listado.Rows.Count > 0 && ex_dgv_P_MonedaHistorico_Listado.SelectedRows.Count > 0)
                {
                    List<long> lst_ids_ABorrar = new List<long>();
                    foreach (DataGridViewRow dgvr in ex_dgv_P_MonedaHistorico_Listado.SelectedRows)
                    {
                        lst_ids_ABorrar.Add(long.Parse(dgvr.Cells[nameof(INTERNO_GEN_MonedasHistoricos_Listado_Modelo.id)].Value.ToString()));
                    }

                    g_obj_Controladora.BorrarDatos_Linea(lst_ids_ABorrar);

                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_NOHAYREGISTROSSELECCIONADOS());
                }
            }
        }
        #endregion

      

        #endregion

        public override void P_Base_ActualizarRegistro_ConObjeto(object _obj, G_ENUM_TIPOACCION _enum_TipoAccion)
        {
            try
            {
                if (_obj != null)
                {
                    if (_enum_TipoAccion.Equals(G_ENUM_TIPOACCION.INT_INSERTAR) ||
                        _enum_TipoAccion.Equals(G_ENUM_TIPOACCION.INT_MODIFICAR))
                    {
                        List<object> lst_obj = (List<object>)_obj;
                        string obj_Opcion = (string)lst_obj[0];

                        //Linea
                        g_obj_Controladora.Linea_Actualizar_Registro((long)lst_obj[1], _enum_TipoAccion, false);

                    }
                    else if (_enum_TipoAccion.Equals(G_ENUM_TIPOACCION.INT_ELIMINAR))
                    {
                        List<object> lst_obj = (List<object>)_obj;
                        string obj_Opcion = (string)lst_obj[0];

                        //Linea
                        g_obj_Controladora.Linea_Borrar_Registro((List<long>)lst_obj[1]);

                    }
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_Moneda) + "/" + nameof(P_Base_ActualizarRegistro_ConObjeto));
            }
        }

        #region Eventos del paginador

        protected void ctu_Paginacion_Primera_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) //Si no han habido contratiempospasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Primera())
                {
                    //Asignando al control la pagina actual.
                    Exferia_Paginador_Monedas.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    //Refrescamos el listado a mostrar en el form
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        private void ctu_Paginacion_Anterior_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Anterior())
                {
                    //Asignando al control la pagina actual.
                    Exferia_Paginador_Monedas.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    //Refrescamos el listado a mostrar en el form
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void ctu_Paginacion_Siguiente_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Siguiente())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Monedas.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void ctu_Paginacion_Ultima_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Ultima())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Monedas.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void txt_PaginaActual_KeyPress(object sender, KeyPressEventArgs e)
        {
            // si pulsamos Enter.
            if (e.KeyChar.Equals('\r'))
            {
                if (g_obj_Controladora.ComprobarCambios()) //Si no han habido contratiempos pasamos a la pagina indicada
                {
                    //Asignamos a la paginacion el valor del textbox
                    g_obj_Funciones_Paginador.SetPaginaActual(Exferia_Paginador_Monedas.txt_ValorPaginaActual - 1);

                    //Asignamos al control la pagina actual
                    Exferia_Paginador_Monedas.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    //Regrescamos el listad a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_obj_Controladora.RecargarDatos();
                }
            }
        }
        #endregion

        #region Teclas de acceso rapido

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        #endregion

        #region Controlar si se modifica algo
        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_CheckBox_CheckedChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_ComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_Exferia_FechaSeleccion_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }


        #endregion

        private void P_Moneda_FormClosed(object sender, FormClosedEventArgs e)
        {
            try
            {
                //Listado ....................................................................
                INTERNO_ConfiguracionPantalla_Modelo mdl_INTERNO_ConfiguracionPantalla_Modelo = new INTERNO_ConfiguracionPantalla_Modelo();

                Dictionary<string, int> dct_ColumnasOrden_INCLUIRREGISTROS = new Dictionary<string, int>();
                Dictionary<string, int> dct_ColumnasAncho_INCLUIRREGISTROS = new Dictionary<string, int>();
                foreach (DataGridViewColumn dgv_Columnas in ex_dgv_P_MonedaHistorico_Listado.Columns)
                {
                    //Campos a Mostrar
                    if (dgv_Columnas.Visible)
                    {
                        //Columnas Orden
                        dct_ColumnasOrden_INCLUIRREGISTROS.Add(dgv_Columnas.Name, dgv_Columnas.DisplayIndex);

                        //Columnas Ancho
                        dct_ColumnasAncho_INCLUIRREGISTROS.Add(dgv_Columnas.Name, dgv_Columnas.Width);
                    }
                }
                mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNASAMOSTRAR = g_obj_Controladora.g_lst_ColumnasAMostrar;
                mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNAS_ORDEN = dct_ColumnasOrden_INCLUIRREGISTROS;
                mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_COLUMNAS_ANCHO = dct_ColumnasAncho_INCLUIRREGISTROS;

                //Orden
                if (ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem != null)
                {
                    mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_ORDEN_COLUMNA_PORDEFECTO = ((INTERNO_ComboBox_Modelo)ex_cbo_P_MonedaHistorico_OrdenListado.SelectedItem).Descripcion;
                }

                mdl_INTERNO_ConfiguracionPantalla_Modelo.LISTADO_ORDEN_DIRECCION_PORDEFECTO = ex_btn_P_MonedaHistorico_OrdenListado.Tag.ToString();

                //Actualizar la Variables General
                if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
                {
                    //Ver si ya existia
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos.NOMBRELISTADO_ALMACENARCONFIGURACION()))
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA[g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos.NOMBRELISTADO_ALMACENARCONFIGURACION()] = mdl_INTERNO_ConfiguracionPantalla_Modelo;
                    }
                    else
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA.Add(g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos.NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo);
                    }
                }
                else
                {
                    Variables.G_DCT_CONFIGURACIONPANTALLA = new Dictionary<string, INTERNO_ConfiguracionPantalla_Modelo>();
                    Variables.G_DCT_CONFIGURACIONPANTALLA.Add(g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos.NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo);
                }

                //Actualizar el fichero XML
                Funciones_FicherosXML.ModificarXML_ConfiguracionPantallas(Variables.G_STR_CONFIGURACIONPANTALLA_TIPOPANTALLA_LISTADOS, g_obj_Controladora.g_obj_ABS_Listado_GEN_MonedasHistoricos.NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo);
                //..........................................................................................................................            
            }
            catch (Exception)
            { }
        }
    }
}
